pipeline {
    agent any
    tools {
        dockerTool 'docker'
        maven 'maven'
    }
    stages {
        stage('Build && SonarQube Analysis') {
            steps {
                sh 'mvn clean package'
                withSonarQubeEnv('Sonar-AWS') {
                    sh 'mvn org.sonarsource.scanner.maven:sonar-maven-plugin:3.7.0.1746:sonar'
                }
            }
        }
        stage('Quality Gate') {
            steps {
                waitForQualityGate abortPipeline: true
            }
        }
        stage('Sending Artifact to Nexus') {
            steps {
                sh """
                curl -v -u jenkins:jenkins \
                --upload-file /var/jenkins_home/workspace/JenkinsStack/target/simple-app-1.0-SNAPSHOT.war \
                http://54.208.248.116:8081/repository/TrackingLab/simple-app-1.0-SNAPSHOT.war
                """
            }
        }
        stage('OWASP ZAP') {
            steps {
                sh """
                docker run -t --name owasp \
                owasp/zap2docker-stable \
                zap-baseline.py -t https://gitlab.com/leonam.amaro/jenkins-stack-lab/ || true
                """
            }
        }
        stage('Removing OWASP ZAP container') {
            steps {
                sh """
                docker stop owasp
                docker rm owasp
                """
            }
        }
    }
    
    post {
        always{
            echo 'Ajudando o Marcos!'
            echo 'Mais 1'
            echo " Outro"
            echo """
            Eu gostaria de \
            colocar mais linhas!
            """
        }
    }
}
